(* ------------------------------------------------------ *)
(*                   WHICHWIN.PAS                         *)
(*   Organisation von Fensternummern unter Turbo Vision   *)
(*         (c) 1991 Jan Laitenberger & DMV-Verlag         *)
(* ------------------------------------------------------ *)
UNIT WhichWin;

INTERFACE

USES Drivers, Views, App;

CONST
  MaxWin = 50;

  FUNCTION WhichWindow: INTEGER;

  FUNCTION ActiveWindow (VAR Event  : tEvent;
                             Number : INTEGER) : BOOLEAN;

IMPLEMENTATION

  FUNCTION WhichWindow;
  VAR
    Nr : BYTE;
  BEGIN
    FOR Nr := 1 TO MaxWin DO
      IF Message(DeskTop, evBroadcast,
                 Nr, NIL) = NIL THEN BEGIN
        WhichWindow := Nr;
        Exit;
      END;
    WhichWindow := -1;
  END;

  FUNCTION ActiveWindow;
  BEGIN
    WITH Event DO
      ActiveWindow := (What = evBroadcast) AND
                      ((Command <= MaxWin) AND
                      (Command = Number));
  END;

END.
(* ------------------------------------------------------ *)
(*             Ende von WHICHWIN.PAS                      *)
